import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.*;

import java.util.*;
import java.awt.image.*;
import java.awt.color.*;

/** 
*/

public class fromRGBtoCYM_ implements PlugInFilter {
	ImagePlus imp;
      	public  int [] Pixels;

  
	public int setup(String arg, ImagePlus imp) {
	  	this.imp = imp;
		int h=imp.getHeight();
		int w=imp.getWidth();			
		this.Pixels=new int[h*w];	
		return DOES_RGB+NO_CHANGES;
	}

	public void run(ImageProcessor ip) {
	        IJ.showProgress(0.1);
		Pixels=(int[])ip.getPixels();
		byte[] C=new byte[this.Pixels.length];
		byte[] Y=new byte[this.Pixels.length];
		byte[] M=new byte[this.Pixels.length];

		this.getCYM(C,Y,M);

		ImagePlus imp2=new ImagePlus(imp.getTitle(), ip);

		//create stack and select X channel
		ColorModel cm = LookUpTable.createGrayscaleColorModel(false);
		ImageStack stack = new ImageStack(imp.getWidth(),imp.getHeight(), cm);
		stack.addSlice("C",C);
		stack.addSlice("Y",Y);
		stack.addSlice("M",M);
		//System.out.println("nombre de slices "+stack.getSize());
		IJ.showProgress(1.0);
		imp2.setStack(null, stack);
    		imp2.show();

	}
       

         public void getCYM(byte[] C, byte[] Y, byte[] M) {
	        int c,r,g,b;
		float[] CYM = new float[3];
		for (int i=0; i < Pixels.length; i++) {
		  c = Pixels[i];
		  r = (c&0xff0000)>>16;
		  g = (c&0xff00)>>8;
		  b = c&0xff;
		  CYM=RGBtoCYM(r,g,b,CYM);
		  C[i] = (byte)((int)(CYM[0]*255.0));
		  Y[i] = (byte)((int)(CYM[1]*255.0));
		  M[i] = (byte)((int)(CYM[2]*255.0));
		}
	 }


         public float[] RGBtoCYM(int r, int g, int b, float[] CYMvals){
	       if (CYMvals==null)
    		  CYMvals =new float[3];
	       
	       CYMvals[0]=0.490f*r+0.310f*g+0.200f*b;
	       CYMvals[1]=0.177f*r+0.812f*g+0.011f*b;
	       CYMvals[2]=0.010f*g+0.990f*b;
	       return CYMvals;
	 }

 /*   public void getLab(byte[] L, byte[] a, byte[] b) {
        int c, L, a, b;
        float[] Lab = new float[3];
        for (int i=0; i < width*height; i++) {
            c = pixels[i];
            r = (c&0xff0000)>>16;
            g = (c&0xff00)>>8;
            b = c&0xff;
//          hsb = Color.RGBtoHSB(r, g, b, hsb);
//            Lab = ColorSpace.fromRGB(r, g, b, Lab);
            L[i] = (byte)((int)(Lab[0]*255.0));
            a[i] = (byte)((int)(Lab[1]*255.0));
            b[i] = (byte)((int)(Lab[2]*255.0));
        }
    }

    public void RGBtoLab(int r, int g, int b, float[] Labvals){
        if (Labvals==null)
	    Labvals float[]=new float[3];
    }
*/




  
}
