import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.*;

import java.util.*;
import java.awt.image.*;
import java.awt.color.*;


/** 22/05/02 E. Glory
    H1H2H3 
    1st component H1 = R+G
    2nd component H2 = R-G
    3rd component H3 = B-(R+G)/2
    ->
*/

public class fromRGBtoH1H2H3_ implements PlugInFilter {
	ImagePlus imp;
        public  int [] Pixels;

  
	public int setup(String arg, ImagePlus imp) {
	  	this.imp = imp;
		int h=imp.getHeight();
		int w=imp.getWidth();		
		this.Pixels=new int[h*w];		
		return DOES_RGB+NO_CHANGES;
	}

	public void run(ImageProcessor ip) {
	        IJ.showProgress(0.1);

	        String title=imp.getTitle();
		String name=title.substring(0,title.indexOf("."));
	
		Pixels=(int[])ip.getPixels();
		byte[] H1=new byte[this.Pixels.length];
		byte[] H2=new byte[this.Pixels.length];
		byte[] H3=new byte[this.Pixels.length];

		this.getH1H2H3(H1,H2,H3);

		ImagePlus imp2=new ImagePlus(imp.getTitle(), ip);
		//imp2.trimProcessor();
		//create stack and select X channel
		ColorModel cm = LookUpTable.createGrayscaleColorModel(false);
		ImageStack stack = new ImageStack(imp.getWidth(),imp.getHeight(), cm);
		stack.addSlice(name+"_H1",H1);
		stack.addSlice(name+"_H2",H2);
		stack.addSlice(name+"_H3",H3);
		//System.out.println("nombre de slices "+stack.getSize());
		IJ.showProgress(1.0);
		imp2.setStack(null, stack);
    		imp2.show();
	}
       
         public void getH1H2H3(byte[] H1, byte[] H2, byte[] H3) {
	        int c,R,G,B;
		float[] H1H2H3 = new float[3];
		for (int i=0; i < Pixels.length; i++) {
		  c = Pixels[i];
		  R = (c&0xff0000)>>16;
		  G = (c&0xff00)>>8;
		  B = c&0xff;
		  H1H2H3=RGBtoH1H2H3(R,G,B,H1H2H3);
		  H1[i] = (byte)((int)(H1H2H3[0]/2));
		  H2[i] = (byte)((int)(H1H2H3[1]/2f+127.5f)); 
		  H3[i] = (byte)((int)(H1H2H3[2]/2f+127.5f));
		}
	 }

         public float[] RGBtoH1H2H3(int R, int G, int B, float[] H1H2H3vals){
	       if (H1H2H3vals==null)
    		  H1H2H3vals =new float[3];

	       H1H2H3vals[0]= R+G;               // [0;510]
	       H1H2H3vals[1]= R-G;               // [-255;255]
	       H1H2H3vals[2]= B-(R+G)/2f;        // [-255;255]
	       return H1H2H3vals;
	 }
}
